<?php
date_default_timezone_set('UTC');
/****************************
 * WDL calendar list version 1.2
 * Author: Web Development Lab of UCONN
 */

/*
 * BEGIN CONFIGURATION OPTIONS
 ***************************/

// URL to read the data from
$FEED_URL = "http://events.uconn.edu/api/rss/?calendar[]=42";

// Number of events to display on the list
$NUMBER_TO_DISPLAY = 5;

/***  Mode Control ----------
 * Put 1 if you wish to load this file as an include
 * Put 2 if you wish to load this file as an iframe
 ***************************/
$MODE = 2;
 
/*
 * END CONFIGURATION OPTIONS
 ***************************/
 
// Load the data
$ch = curl_init($FEED_URL);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); 
$output = curl_exec($ch);
curl_close($ch);
$data = $output;
$data=eregi_replace(">"."[[:space:]]+"."< ",">< ",$data);
// Current state info
$in_item = false;
$tag_name = '';
$parsed_data = array();
$item_index = -1;

$xmlparser = xml_parser_create() or die ("Cannot create parser");
xml_set_element_handler($xmlparser, "start_tag", "end_tag");
xml_set_character_data_handler($xmlparser, "tag_contents");
xml_parse($xmlparser, $data, true);

if($MODE == 2){
	echo '
		<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
		<html xmlns="http://www.w3.org/1999/xhtml">
		<head>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		<title>Impending Events</title>
	';
	loadStyle();
	echo '
		</head>
		<body>
	';
} else if ($MODE == 1){
	loadStyle();
}

?>
<div id="event_upcoming">
		<h3>Upcoming Events</h3>
		<ul>
		<?php
		$num_shown = 0;
		// If we got data, then display it
		if ( $data !== false ) {
			
			$num_shown = 0;
			if(count($parsed_data) != 0){
				
				foreach ( $parsed_data as $data ) {
					if ( $num_shown < $NUMBER_TO_DISPLAY ){
						$imgurl = explode(':imgurl:',$data['description']);
						$s_timestamp = explode(':s_timestamp:',$data['description']);
						echo '<li><a href="'.$data['link'].'">';
						if( isset($imgurl[1]) ){
							echo '<img src="'.$imgurl[1].'" width="63" height="63" alt="image" />';
						}
						echo $data['title'].'<span>'.date("l, F d, Y ",$s_timestamp[1]).'<br />'.date("g:i a",$s_timestamp[1]).'</span></a></li>';
						$num_shown++;
					}
				}
			} else {
					echo '	<li>
								<span>&infin;</span> No existing events in sight
							</li>';
			}
		}
		?>
		</ul>
</div>
<?php
if($MODE == 2){
	echo '
		</body>
		</html>
	';
}

function start_tag($parser, $name, $attribs) {
	global $in_item, $item_index, $parsed_data, $tag_name;

	if ( $in_item )
		$tag_name = strtolower($name);
	
	if ( $name == 'ITEM' ) {
		$in_item = true;
		$item_index++;
		$parsed_data[$item_index] = array(
			'title' => '',
			'link' => '',
			'description' => ''
		);
	}
}

function end_tag($parser, $name) {
	global $in_item, $item_index, $parsed_data, $tag_name;
	
	if ( $name == 'ITEM' )
		$in_item = false;
		
	if ( $in_item )
		$tag_name = '';
}

function tag_contents($parser, $data) {
	global $in_item, $item_index, $parsed_data, $tag_name;

	if ( $in_item && trim($data) ){
		$parsed_data[$item_index][$tag_name] = $data;
	}
}

function loadStyle(){
	echo '
		<style type="text/css">
		#event_upcoming {font-family:Verdana, Arial, Helvetica, sans-serif; font-size:14px;}
		#event_upcoming h3 {font:bold 1em Arial, Helvetica, sans-serif;}
		#event_upcoming ul, #upcoming li {margin:0; padding:0; list-style-type:none;}
		#event_upcoming li {height:1%; font-size:.9em;z}
		#event_upcoming a {display:block; padding:10px 10px 10px 75px; min-height:50px; _height:50px; text-decoration:none; position:relative; color:#333333;}
		#event_upcoming a img {position:absolute; top:0; left:0; _left:-75px; border:0;}
		#event_upcoming li span{font-size:1.6em; vertical-align:sub; color:#999999; padding-right:15px; font-style:normal; }
		#event_upcoming a:hover {color:#0066CC; text-decoration:underline;}
		#event_upcoming a span {display:block; font-size:.7em; color:#666666; text-decoration:none;}
		</style>
	';
}
?>