<?php
/****************************
 * WDL calendar list version 1.2b (lite)
 * Author: Web Development Lab of UCONN
 */

// URL to read the data from
$FEED_URL = "http://events.uconn.edu/api/rss/?calendar[]=42";

// Number of events to display on the list
$NUMBER_TO_DISPLAY = 5;

/***  Mode Control ----------
 * Put 1 if you wish to load this file as an include
 * Put 2 if you wish to load this file as an iframe
 ***************************/
$MODE = 1;

/*
 * END CONFIGURATION OPTIONS
 ***************************/

// Load the data
$cache_file = "event_cache";
$data = "";
// check if cache file exists and if so, check when the file was created.
// if created less than 3 minutes ago, load data from the file instead
if ((is_readable($cache_file)) && (time() - filemtime($cache_file)) < 180)
{
	$cache_fd = fopen($cache_file, "r");
	$data = fread($cache_fd, filesize($cache_file));
	fclose($cache_fd);
}
else // else, load the feed from the URL and overwrite the file
{
	$ch = curl_init($FEED_URL);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); 
	$output = curl_exec($ch);
	curl_close($ch);
	$data = $output;
	$data=eregi_replace(">"."[[:space:]]+"."< ",">< ",$data);
	$cache_fd = fopen($cache_file, "w");
	fwrite($cache_fd, $data);
	fclose($cache_fd);
}

// Current state info
$in_item = false;
$tag_name = '';
$parsed_data = array();
$item_index = -1;

$xmlparser = xml_parser_create() or die ("Cannot create parser");
xml_set_element_handler($xmlparser, "start_tag", "end_tag");
xml_set_character_data_handler($xmlparser, "tag_contents");
xml_parse($xmlparser, $data, true);

// If we got data, then display it
if($MODE == 2){
	echo '
		<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
		<html xmlns="http://www.w3.org/1999/xhtml">
		<head>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		<title>Impending Events</title>
	';
	loadStyle();
	echo '
		</head>
		<body>
	';
} else if ($MODE == 1){
	loadStyle();
}

if ( $data !== false ) {
	echo '<div id="event_upcoming_lite">';
	echo '<h3>Upcoming Events</h3>';
	echo '<ul >';
	
	$num_shown = 0;
	if(count($parsed_data) != 0){
		foreach ( $parsed_data as $data ) {
		
			if ( $num_shown < $NUMBER_TO_DISPLAY ) {
				echo '<li>';
				echo '<a href="'.$data['link'].'" target="parent">';
				$date = explode('/',$data['description']);
				echo "<em>".substr(trim($date[0]),7)."&#47;".$date[1]."</em> ";
				echo $data['title'];
				echo '</a>';
				echo '</li>';
				$num_shown++;
			}
		}
	} else {
		echo '	<li>
					<span>&infin;</span> No existing events in sight
				</li>';
	}

	echo '</ul>';
	echo '</div>';
}

// Otherwise, display an error message
else {
	echo '<div id="events">';
	echo '<p class="error">Error loading calendar.</p>';
	echo '</div>';
}
if($MODE == 2){
	echo '
		</body>
		</html>
	';
}

function start_tag($parser, $name, $attribs) {
	global $in_item, $item_index, $parsed_data, $tag_name;

	if ( $in_item )
		$tag_name = strtolower($name);
	
	if ( $name == 'ITEM' ) {
		$in_item = true;
		$item_index++;
		$parsed_data[$item_index] = array(
			'title' => '',
			'link' => '',
			'description' => ''
		);
	}
}

function end_tag($parser, $name) {
	global $in_item, $item_index, $parsed_data, $tag_name;
	
	if ( $name == 'ITEM' )
		$in_item = false;
		
	if ( $in_item )
		$tag_name = '';
}

function tag_contents($parser, $data) {
	global $in_item, $item_index, $parsed_data, $tag_name;

	if ( $in_item && trim($data) )
		$parsed_data[$item_index][$tag_name] = $data;
}
function loadStyle(){
	echo '
		<style type="text/css">
			#event_upcoming_lite ul, #event_upcoming_lite li {padding:0; margin:0; list-style-type:none;}
			#event_upcoming_lite a {text-decoration:none;}
			#event_upcoming_lite a:link, #event_upcoming_lite a:visited {color:#333333; border-bottom-width:0; display:block; padding:5px; width:283px; overflow:hidden; white-space:nowrap;}
			#event_upcoming_lite a:visited {color:#666666;}
			#event_upcoming_lite a:hover {background-color:#efefef;}
			#event_upcoming_lite a em {color:#999999; padding-right:15px; font-style:normal;}
			#event_upcoming_lite li span{font-size:1.6em; vertical-align:sub; color:#999999; padding-right:15px; font-style:normal;}
			#event_upcoming_lite li+li {border-top:1px solid #cccccc;}
			#event_upcoming_lite {width:293px;}
		</style>
	';
}

?>